libstdc++: __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc > Class Template Reference

libstdc++

__gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc > Class Template Reference

`#include <node_iterators.hpp>`

Inheritance diagram for __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >:
[legend]

## Public Types
typedef rebind_traits< _Alloc, typenameremove_const< Value_Type >::type >::const_pointer | const_reference
typedef trivial_iterator_difference_type | difference_type
typedef trivial_iterator_tag | iterator_category
typedef rebind_traits< _Alloc, metadata_type >::const_reference | metadata_const_reference
typedef Metadata_Type | metadata_type
typedef rebind_traits< _Alloc, typenameremove_const< Value_Type >::type >::const_pointer | reference
typedef rebind_traits< _Alloc, Value_Type >::const_pointer | value_type

## Public Member Functions
| ov_tree_node_const_it_ (const_pointer p_nd=0, const_pointer p_begin_nd=0, const_pointer p_end_nd=0, const_metadata_pointer p_metadata=0)
this_type | get_l_child () const
metadata_const_reference | get_metadata () const
this_type | get_r_child () const
bool | operator!= (const this_type &other) const
const_reference | operator* () const
bool | operator== (const this_type &other) const

## Public Attributes
pointer | m_p_begin_value
pointer | m_p_end_value
const_metadata_pointer | m_p_metadata
pointer | m_p_value

## Protected Types
typedef rebind_traits< _Alloc, Metadata_Type >::const_pointer | const_metadata_pointer
typedef rebind_traits< _Alloc, Value_Type >::const_pointer | const_pointer
typedef rebind_traits< _Alloc, Value_Type >::pointer | pointer
typedef ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc > | this_type

## Static Protected Member Functions
template<typename Ptr>
static Ptr | mid_pointer (Ptr p_begin, Ptr p_end)

## Detailed Description

template<typename Value_Type, typename Metadata_Type, typename _Alloc>
class __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >

Const node reference.

Definition at line 57 of file ov_tree_map_/node_iterators.hpp.

## Member Typedef Documentation

## ◆ const_metadata_pointer

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef rebind_traits<_Alloc,Metadata_Type>::const_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::const_metadata_pointer
| protected

Definition at line 68 of file ov_tree_map_/node_iterators.hpp.

## ◆ const_pointer

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef rebind_traits<_Alloc,Value_Type>::const_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::const_pointer
| protected

Definition at line 65 of file ov_tree_map_/node_iterators.hpp.

## ◆ const_reference

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef rebind_traits<_Alloc,typenameremove_const<Value_Type>::type>::const_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::const_reference

Definition at line 97 of file ov_tree_map_/node_iterators.hpp.

## ◆ difference_type

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef trivial_iterator_difference_type __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::difference_type

Definition at line 86 of file ov_tree_map_/node_iterators.hpp.

## ◆ iterator_category

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef trivial_iterator_tag __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::iterator_category

Definition at line 84 of file ov_tree_map_/node_iterators.hpp.

## ◆ metadata_const_reference

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef rebind_traits<_Alloc,metadata_type>::const_reference __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::metadata_const_reference

Definition at line 102 of file ov_tree_map_/node_iterators.hpp.

## ◆ metadata_type

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef Metadata_Type __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::metadata_type

Definition at line 99 of file ov_tree_map_/node_iterators.hpp.

## ◆ pointer

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef rebind_traits<_Alloc,Value_Type>::pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::pointer
| protected

Definition at line 62 of file ov_tree_map_/node_iterators.hpp.

## ◆ reference

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef rebind_traits<_Alloc,typenameremove_const<Value_Type>::type>::const_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::reference

Definition at line 93 of file ov_tree_map_/node_iterators.hpp.

## ◆ this_type

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef ov_tree_node_const_it_<Value_Type, Metadata_Type, _Alloc> __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::this_type
| protected

Definition at line 70 of file ov_tree_map_/node_iterators.hpp.

## ◆ value_type

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

typedef rebind_traits<_Alloc,Value_Type>::const_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::value_type

Definition at line 89 of file ov_tree_map_/node_iterators.hpp.

## Constructor & Destructor Documentation

## ◆ ov_tree_node_const_it_()

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

__gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::ov_tree_node_const_it_ | ( | const_pointer | p_nd = 0,
|  | const_pointer | p_begin_nd = 0,
|  | const_pointer | p_end_nd = 0,
|  | const_metadata_pointer | p_metadata = 0 )
| inline

Definition at line 106 of file ov_tree_map_/node_iterators.hpp.

## Member Function Documentation

## ◆ get_l_child()

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

this_type __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::get_l_child | ( |  | ) | const
| inline

Returns the node iterator associated with the left node.

Definition at line 135 of file ov_tree_map_/node_iterators.hpp.

## ◆ get_metadata()

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

metadata_const_reference __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::get_metadata | ( |  | ) | const
| inline

Definition at line 121 of file ov_tree_map_/node_iterators.hpp.

## ◆ get_r_child()

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

this_type __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::get_r_child | ( |  | ) | const
| inline

Returns the node iterator associated with the right node.

Definition at line 151 of file ov_tree_map_/node_iterators.hpp.

## ◆ mid_pointer()

template<typename Value_Type, typename Metadata_Type, typename _Alloc>
template<typename Ptr>

Ptr __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::mid_pointer | ( | Ptr | p_begin,
|  | Ptr | p_end )
| inlinestaticprotected

Definition at line 76 of file ov_tree_map_/node_iterators.hpp.

## ◆ operator!=()

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

bool __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::operator!= | ( | const this_type & | other | ) | const
| inline

Definition at line 181 of file ov_tree_map_/node_iterators.hpp.

## ◆ operator*()

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

const_reference __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::operator* | ( |  | ) | const
| inline

Definition at line 117 of file ov_tree_map_/node_iterators.hpp.

## ◆ operator==()

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

bool __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::operator== | ( | const this_type & | other | ) | const
| inline

Definition at line 166 of file ov_tree_map_/node_iterators.hpp.

## Member Data Documentation

## ◆ m_p_begin_value

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::m_p_begin_value

Definition at line 186 of file ov_tree_map_/node_iterators.hpp.

## ◆ m_p_end_value

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::m_p_end_value

Definition at line 187 of file ov_tree_map_/node_iterators.hpp.

## ◆ m_p_metadata

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

const_metadata_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::m_p_metadata

Definition at line 189 of file ov_tree_map_/node_iterators.hpp.

## ◆ m_p_value

template<typename Value_Type, typename Metadata_Type, typename _Alloc>

pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::m_p_value

Definition at line 185 of file ov_tree_map_/node_iterators.hpp.

The documentation for this class was generated from the following file:

- ov_tree_map_/node_iterators.hpp